'-----------------------------------------------------------------------------------------
'name                     : attiny2313_alps_1.bas
'copyright                : (c) danzup
'purpose                  : Preamp controller
'micro                    : Attiny2313
'version                  : 1.0
' this version with 4 input, RC5 remote control & motorized alps volume potentiometer ,
' smooth command for alps
'-----------------------------------------------------------------------------------------
$regfile = "attiny2313.dat"                                 ' specify the used micro
$crystal = 8000000                                          ' used crystal frequency
Config Portd.6 = Output                                     'power relay
Config Portd.7 = Output                                     'led on/off si ir martor
Config Portb = Output
Dim Address As Byte , Command As Byte                       'RC5 ir variable
Dim W As Word
Dim Inp_sel As Word
Dim Pwr As Bit
Pwr = 1                                                     '0 =stand-by ; 1 = power on
Set Portd.6                                                 'will set  power relay on
Set Portd.7                                                 'led off
Declare Sub Shiftlf                                         'name say all for subroutine ...doh!!
Declare Sub Shiftrt
Declare Sub Volup
Declare Sub Voldn
Declare Sub Pwronof
Declare Sub Poweron
Declare Sub Poweroff
Config Timer1 = Timer , Prescale = 1024
Stop Timer1
Config Rc5 = Pind.2                                         'pin where is conected ir senzor                                                'backlight on
Portb = &B01110000                                          ' PORTB.2 and PORTB.3 motor control lines for alps pot
Inp_sel = 0                                                 ' 0 =mute , 1 = normal
Enable Interrupts
Start Timer1
Do
If Pwr = 1 Then
 W = Timer1
 If W => 156 Then
  Set Portb.3
  Set Portb.2
 End If
 Getrc5(address , Command)                                  'read if we have remote ir command
  If Address = 20 Then
     Command = Command And &B01111111
     Reset Portd.6
  End If
 Select Case Command
 '---- this codes are for my remote , change code to your suit ! ----------------
   Case 52 : Call Shiftlf                                   'remote command code for CH up
   Case 50 : Call Shiftrt                                   'remote command code for CH down
   Case 32 : Call Volup                                     'remote command code for Vol +
   Case 33 : Call Voldn                                     'remote command code for Vol -
   Case 180 : Call Shiftlf                                  'remote command code for CH up
   Case 178 : Call Shiftrt                                  'remote command code for CH down
   Case 160 : Call Volup                                    'remote command code for Vol +
   Case 161 : Call Voldn                                    'remote command code for Vol -
   Case 140 : Call Pwronof
   Case 12 : Call Pwronof
   Case Else : Set Portd.6
 End Select
End If

If Pwr = 0 Then
 Getrc5(address , Command)                                  'read if we have remote ir command
  If Address = 8 Then
     Command = Command And &B01111111
  End If
 Select Case Command
   Case 140 : Call Pwronof
   Case 12 : Call Pwronof
 End Select
End If

Loop
End
'---------shift input Left----------
Sub Shiftlf:
W = 0
Timer1 = W
If Inp_sel < 3 Then
Inp_sel = Inp_sel + 1
Select Case Inp_sel
Case 0 : Reset Portb.7
          Set Portb.6
          Set Portb.5
          Set Portb.4
Case 1 : Set Portb.7
          Reset Portb.6
          Set Portb.5
          Set Portb.4
Case 2 : Set Portb.7
          Set Portb.6
         Reset Portb.5
          Set Portb.4
Case 3 : Set Portb.7
          Set Portb.6
          Set Portb.5
          Reset Portb.4
End Select
End If
Waitms 30
Set Portd.6
End Sub
'--------shift input right----------
Sub Shiftrt:
W = 0
Timer1 = W
If Inp_sel > 0 Then
Inp_sel = Inp_sel - 1
Select Case Inp_sel
Case 0 : Reset Portb.7
          Set Portb.6
          Set Portb.5
          Set Portb.4
Case 1 : Set Portb.7
          Reset Portb.6
          Set Portb.5
          Set Portb.4
Case 2 : Set Portb.7
          Set Portb.6
         Reset Portb.5
          Set Portb.4
Case 3 : Set Portb.7
          Set Portb.6
          Set Portb.5
          Reset Portb.4
End Select
End If
Waitms 30
Set Portd.6
End Sub
'-------bring volume up-------------
Sub Volup:
W = 0
Timer1 = W
Reset Portb.3
Waitms 20
Set Portd.6
End Sub
'--------bring volume down----------
Sub Voldn:
W = 0
Timer1 = W
Reset Portb.2
Waitms 20
Set Portd.6
End Sub
'-----------Pwr_onof-----------------
Sub Pwronof:
   Pwr = Not Pwr
   If Pwr = 1 Then
      Call Poweron
   Else
      Call Poweroff
   End If
End Sub
'------Poweron------------------------
Sub Poweron:
Set Portd.6                                                 'will set  power relay on
Set Portd.7                                                 'led off
Select Case Inp_sel
Case 0 : Reset Portb.7
          Set Portb.6
          Set Portb.5
          Set Portb.4
Case 1 : Set Portb.7
          Reset Portb.6
          Set Portb.5
          Set Portb.4
Case 2 : Set Portb.7
          Set Portb.6
         Reset Portb.5
          Set Portb.4
Case 3 : Set Portb.7
          Set Portb.6
          Set Portb.5
          Reset Portb.4
End Select
Waitms 300
End Sub
'-------Poweroff----------------------
Sub Poweroff:
Reset Portd.6                                               'will set  power relay off
Reset Portd.7                                               'will set the led on
Portb = &B11110000                                          ' mute   input source
Waitms 300
End Sub